In act.informative.c
add/ replace these functions:   (ensure you change the declarations on the top)

void list_obj_to_char(struct obj_data *list, struct char_data *ch, int mode, bool show)
{
  struct obj_data *i, *j;
  char buf[10];
  bool found;
  int num;
  /* this function adds in obj stacking so instead of:
   * an arrow
   * an arrow
   * you get this:
   * (2) an arrow
   */
  found = FALSE;
  for (i = list; i; i = i->next_content) {
	  num = 0;
	  for (j = list; j != i; j = j->next_content)
  if (j->item_number==NOTHING) {
	 if(strcmp(j->short_description,i->short_description)==0) break;
  }
  else if (j->item_number==i->item_number) break;
		if (j!=i) continue;
		for (j = i; j; j = j->next_content)
  if (j->item_number==NOTHING) {
	 if(strcmp(j->short_description,i->short_description)==0) num++;
  }
  else if (j->item_number==i->item_number) num++;
		if (CAN_SEE_OBJ(ch, i)) {
	if (num!=1) {
  send_to_char(ch,"(%2i) ",num);
	}
  show_obj_to_char(i, ch, mode);
  found = TRUE;
	}
  }
  if (!found && show)
	send_to_char(ch, " Nothing.\r\n");
}

 /* these functions allow you to look into the rooms next to the one your in */

void char_to_dir(struct char_data *ch, room_rnum room)
{
	ch->next_in_room = world[room].people;
	world[room].people = ch;
	ch->in_room = room;
}

void char_from_dir(struct char_data *ch)
{
	struct char_data *temp;

	if (FIGHTING(ch) !=NULL)
		stop_fighting(ch);

	REMOVE_FROM_LIST(ch, world[ch->in_room].people, next_in_room);
	ch->in_room = NOWHERE;
	ch->next_in_room = NULL;
}

void look_in_direction(struct char_data *ch, int dir)
{
  int was_in;

  if (EXIT(ch, dir)) {
	if (!EXIT_FLAGGED(EXIT(ch, dir), EX_CLOSED)) {
	   was_in = ch->in_room;
	   char_from_dir(ch);
	   char_to_dir(ch, world[was_in].dir_option[dir]->to_room);
		
	  
	   look_at_room(ch, 0);

	   char_from_dir(ch);    
	   char_to_dir(ch, was_in);

	   send_to_char(ch, "");

	}    
	if (EXIT_FLAGGED(EXIT(ch, dir), EX_CLOSED)) 
	  send_to_char(ch, "The %s is closed.\r\n", fname(EXIT(ch, dir)->keyword));
	}
	else
	send_to_char(ch, "Nothing special there...\r\n");
}


in constants.c in the function:

const char *item_types[] = {
+  "BOW",
+  "SLING",
+  "CROSSBOW",
+  "BOLT",
+  "ARROW",
+  "ROCK",

I would recommend replace fireweapon and missile with the some of these
they are not used in the stock mud however just deleting them will cause problems
the obj you already have in the game.

 in fight.c

 +/* Daniel Houghton's revision */
+extern int rev_dir[];
+extern struct index_data *obj_index;
+extern struct room_data *world;
+  

 void damage(struct char_data * ch, struct char_data * victim, int dam,
 	    int attacktype)
 {
+	/* Daniel Houghton's missile modification */
+	bool missile = FALSE;
+	
   if (GET_POS(victim) <= POS_DEAD) {
     log("SYSERR: Attempt to damage a corpse.");
     die(victim);
     return;			/* -je, 7/7/92 */
   }
+  
+	/* Daniel Houghton's missile modification */
+	if (ch->in_room != victim->in_room)
+		missile = TRUE;
 
   /* peaceful rooms */
   if (ch != victim && ROOM_FLAGGED(ch->in_room, ROOM_PEACEFUL)) {
@@ -633,8 +649,9 @@
   /* You can't damage an immortal! */
   if (!IS_NPC(victim) && (GET_LEVEL(victim) >= LVL_IMMORT))
     dam = 0;
-
-  if (victim != ch) {
+    
+	/* Daniel Houghton's missile modification */
+	if ((victim != ch) && (!missile)) {
     /* Start the attacker fighting the victim */
     if (GET_POS(ch) > POS_STUNNED && (FIGHTING(ch) == NULL))
       set_fighting(ch, victim);
@@ -662,8 +679,11 @@
   /* Check for PK if this is not a PK MUD */
   if (!pk_allowed) {
     check_killer(ch, victim);
+	/* Daniel Houghton's modification:  Let the PK flag be enough! */
+	/*
     if (PLR_FLAGGED(ch, PLR_KILLER) && (ch != victim))
       dam = 0;
+	*/
   }
 
   /* Set the maximum damage per round and subtract the hit points */
@@ -671,7 +691,7 @@
   GET_HIT(victim) -= dam;
 
   /* Gain exp for the hit */
-  if (ch != victim)
+	if ((ch != victim) && (!missile))
     gain_exp(ch, GET_LEVEL(victim) * dam);
 
   update_pos(victim);
@@ -687,7 +707,7 @@
    * death blow, send a skill_message if one exists; if not, default to a
    * dam_message. Otherwise, always send a dam_message.
    */
-  if (!IS_WEAPON(attacktype))
+    if ((!IS_WEAPON(attacktype)) || missile)
     skill_message(dam, ch, victim, attacktype);
   else {
     if (GET_POS(victim) == POS_DEAD || dam == 0) {


in interpreter.c

+ACMD(do_shoot);


+  { "shoot"    , POS_STANDING, do_shoot    , 0, 0},

in spell_parser.c

skillo(SKILL_RANGE_COMBAT, "range combat");

in spells.h:

#define SKILL_RANGE_COMBAT    xxx /* next avail number */

in structs.h
ADD in item_types (make numbers next avail)

#define ITEM_BOW       26               /* shoots arrows */
#define ITEM_SLING     27               /* shoots rocks */
#define ITEM_CROSSBOW  28               /* shoots bolts */
#define ITEM_BOLT      29
#define ITEM_ARROW     30
#define ITEM_ROCK      31

in util.h add these (Im not really sure if they are used in rangee.c
but I figured better safe than sorry)

+#define EXIT2(roomnum, door) (world[(roomnum)].dir_option[door])
+#define CAN_GO2(roomnum, door) (EXIT2(roomnum, door) && \
+                       (EXIT2(roomnum, door)->to_room != NOWHERE) && \
+                       !IS_SET(EXIT2(roomnum,door)->exit_info, EX_CLOSED))


**** if You use oasis OLC add this to oedit.c****

@@ -596,6 +596,17 @@
      */
     oedit_disp_val3_menu(d);
     break;
+		case ITEM_BOW:
+    case ITEM_CROSSBOW:
+    case ITEM_SLING:
+       write_to_output(d, "Range (1 - 3): ");
+      break;
+    case ITEM_ROCK:
+    case ITEM_BOLT:
+    case ITEM_ARROW:
+      oedit_disp_val2_menu(d);
+      break;
   case ITEM_SCROLL:
   case ITEM_WAND:
   case ITEM_STAFF:
@@ -629,6 +640,9 @@
      * This is supposed to be language, but it's unused.
      */
     break;

@@ -649,6 +663,11 @@
   case ITEM_STAFF:
     send_to_char("Max number of charges : ", d->character);
     break;
+  case ITEM_ROCK:
+  case ITEM_BOLT:
+  case ITEM_ARROW:
   case ITEM_WEAPON:
     send_to_char("Number of damage dice : ", d->character);
     break;
@@ -691,6 +710,11 @@
   case ITEM_STAFF:
     send_to_char("Number of charges remaining : ", d->character);
     break;
+	case ITEM_ROCK:
+	case ITEM_BOLT:
+	case ITEM_ARROW:
   case ITEM_WEAPON:
     send_to_char("Size of damage dice : ", d->character);
     break;


then go into oasis.h and increase the no of item_types


